# win_http_proxy – Manages proxy settings for WinHTTP

New in version 2.8.

- Synopsis

- Parameters

- Notes

- See Also

- Examples

- Status

## Synopsis

- Used to set, remove, or import proxy settings for Windows HTTP Services `WinHTTP`.

- WinHTTP is a framework used by applications or services, typically .NET applications or non-interactive services, to make web requests.

## Parameters

Parameter | Choices/Defaults | Comments
--- | --- | ---
bypass list |  | A list of hosts that will bypass the set proxy when being accessed. Use `<local>` to match hostnames that are not fully qualified domain names. This is useful when needing to connect to intranet sites using just the hostname. Omit, set to null or an empty string/list to remove the bypass list. If this is set then proxy must also be set.

proxy
-

A string or dict that specifies the proxy to be set.
If setting a string, should be in the form `hostname`, `hostname:port`, or `protocol=hostname:port`.
If the port is undefined, the default port for the protocol in use is used.
If setting a dict, the keys should be the protocol and the values should be the hostname and/or port for that protocol.
Valid protocols are `http`, `https`, `ftp`, and `socks`.
Omit, set to null or an empty string to remove the proxy settings.

source
string

Choices:
- ie

Instead of manually specifying the proxy and/or bypass, set this to import the proxy from a set source like Internet Explorer.
Using `ie` will import the Internet Explorer proxy settings for the current active network connection of the current user.
Only IE's proxy URL and bypass list will be imported into WinHTTP.
This is like running `netsh winhttp import proxy source=ie`.
The value is imported when the module runs and will not automatically be updated if the IE configuration changes in the future. The module will have to be run again to sync the latest changes.

## Notes

Note

- This is not the same as the proxy settings set in Internet Explorer, also known as `WinINet`; use the win_inet_proxy module to manage that instead.

- These settings are set system wide and not per user, it will require Administrative privileges to run.

## See Also

See also

win_inet_proxy – Manages proxy settings for WinINet and Internet Explorer

  The official documentation on the win_inet_proxy module.

## Examples

    - name: Set a proxy to use for all protocols
      win_http_proxy:
        proxy: hostname

    - name: Set a proxy with a specific port with a bypass list
      win_http_proxy:
        proxy: hostname:8080
        bypass:
        - server1
        - server2
        - <local>

    - name: Set the proxy based on the IE proxy settings
      win_http_proxy:
        source: ie

    - name: Set a proxy for specific protocols
      win_http_proxy:
        proxy:
          http: hostname:8080
          https: hostname:8443

    - name: Set a proxy for specific protocols using a string
      win_http_proxy:
        proxy: http=hostname:8080;https=hostname:8443
        bypass: server1,server2,<local>

    - name: Remove any proxy settings
      win_http_proxy:
        proxy: ''
        bypass: ''

## Status

- This module is not guaranteed to have a backwards compatible interface. [preview]

- This module is maintained by the Ansible Community. [community]

### Authors

- Jordan Borean (@jborean93)

Hint

If you notice any issues in this documentation, you can edit this document to improve it.